#include "X3D_Appearance.h"
#include "X3D_X3DMaterialNode.h"
#include "X3D_X3DTextureNode.h"
#include "X3D_X3DTextureTransformNode.h"
#include "X3D_LineProperties.h"
#include "X3D_FillProperties.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

Appearance::Appearance()
: X3DAppearanceNode()
{
  define(Recorder<Appearance>::getTypeName("Appearance", "Shape"));

  define(Recorder<Appearance, X3DMaterialNode>::getSFNode("material", &Appearance::_material));
  define(Recorder<Appearance, X3DTextureNode>::getSFNode("texture", &Appearance::_texture));
  define(Recorder<Appearance, X3DTextureTransformNode>::getSFNode("textureTransform", &Appearance::_textureTransform));
  define(Recorder<Appearance, LineProperties>::getSFNode("lineProperties", &Appearance::_lineProperties));
  define(Recorder<Appearance, FillProperties>::getSFNode("fillProperties", &Appearance::_fillProperties));
}

Appearance::~Appearance()
{
  removeChildren();
}

}
}
