#include "MESH_ConnectedComComputerStateVariables.h"
#include "MemReleaser.h"

namespace X3DTK {
namespace MESH {

ConnectedComComputerStateVariables::ConnectedComComputerStateVariables()
: StateVariables()
{
}

void ConnectedComComputerStateVariables::init()
{
}

void ConnectedComComputerStateVariables::finish()
{
  _vertexSetList.clear();
  MemReleaser *memreleaser = Singleton<MemReleaser>::getInstance();
  
  for (MFNode::const_iterator it = _toDeleteNodes.begin(); it != _toDeleteNodes.end(); ++it)
    memreleaser->release(*it);
  
  _toDeleteNodes.clear();
}

void ConnectedComComputerStateVariables::addNode(SFNode N)
{
  _vertexSetList.push_back(N);
}

bool ConnectedComComputerStateVariables::getNode(SFNode N) const
{
  std::list<SFNode>::const_iterator it = std::find(_vertexSetList.begin(), _vertexSetList.end(), N);
  return (it != _vertexSetList.end());
}

void ConnectedComComputerStateVariables::setSelectedNodes(const MFNode &selectedNodes)
{
  _selectedNodes = selectedNodes;
}

MFNode ConnectedComComputerStateVariables::getSelectedNodes() const
{
  return _selectedNodes;
}

void ConnectedComComputerStateVariables::addToDeleteNode(SFNode node)
{
  _toDeleteNodes.push_back(node);
}

void ConnectedComComputerStateVariables::setProgress(Progress *progress)
{
  _progress = progress;
}

}
}
