#include "Cloner.h"
#include "X3DAbstractNode.h"
#include "DFSGraphTraversal.h"
#include "ClonerAbstractVisitor.h"

namespace X3DTK {

Cloner::Cloner()
{
  setGraphTraversal(new DFSGraphTraversal());
  setComponentVisitor(new ClonerAbstractVisitor());
}

Cloner::~Cloner()
{
  Singleton<ClonerStateVariables>::removeInstance();
}
  
SFNode Cloner::clone(SFNode N, bool reset) const
{
  Singleton<ClonerStateVariables>::getInstance()->initRoot();
  if (reset)
    Singleton<ClonerStateVariables>::getInstance()->init();
    
  traverse(N);

  if (reset)  
    Singleton<ClonerStateVariables>::getInstance()->finish();
  
  return Singleton<ClonerStateVariables>::getInstance()->getRoot();
}

void Cloner::init()
{
  Singleton<ClonerStateVariables>::getInstance()->init();
}

void Cloner::finish()
{
  Singleton<ClonerStateVariables>::getInstance()->finish();
}
  
}
